(document:surround "/std/base")
(document:insert "/std/functions")

(document:envelop with-translation _ "alterator-packages")

title (_ "Updating Indices...")

(define *packages-progress-error* (make-cell '()))

(define (progress-handler args)
  (let ((command (car args))
        (arg (cadr args))
        (rest (if (pair? (cddr args)) (caddr args) "")))
    (cond
     ;; begin
     ((and (string=? command "progress")
           (string=? arg "begin"))
      (label-id text (_ "Preparing...")))
     ;; start update
     ((and (string=? command "progress")
           (string=? arg "update"))
      (label-id text (_ "Updating..."))
      (bar-id maximum (string->number rest) value 0)
      (text-id text ""))
     ;; update progress bar
     ((string=? command "step")
      (text-id append-text arg)
      (bar-id value (1+ (bar-id value))))
     ;; accumulate errors
     ((string=? command "error")
      (cell-set! *packages-progress-error*
                 (acons arg rest (cell-ref *packages-progress-error*))))
     ;; normal termination
     ((and (string=? command "progress")
           (string=? arg "end"))
      (document-exit (or (null? (cell-ref *packages-progress-error*))
                         (cell-ref *packages-progress-error*))))
     ;; abort
     ((and (string=? command "progress")
           (string=? arg "abort"))
      (document-exit #f))
     ;; uncatched
     (else
      (text-id append-text (string-append "XXX" command ":" arg "\n"))))))

(define (document-exit value)
  (remove-mailbox progress-handler)
  (document:end value)
  (simple-notify document:root 'action "retry"))

(document:id label-id (label (_ "Updating Indices...")))
(document:id text-id (textbox "" alterability #f))
(document:id bar-id (progressbar maximum 1 value 0))

(document:root
 (when loaded
   (add-mailbox progress-handler)
   (woo-write "/packages/control" 'control "quit")
   (woo-write "/packages/control" 'control "update")))
