(document:envelop let () )

(define *groups-major-current* (make-cell #f))
(define *groups-minor-current* (make-cell #f))

(define (groups-major)
  (woo-list-names "/packages/groups"))

(define (groups-label->group label)
  (assoc-ref (cell-ref *groups-major-labels*) label))

(define (groups-minor label)
  (cell-set! *groups-major-current* label)
  (cell-set! *groups-minor-current*
             (groups-minor-1
              (cell-ref *groups-major-current*)))
  (cell-ref *groups-minor-current*))

(define (groups-minor-1 group)
  (sort (map
         (lambda (e)
           (cons (woo-get-option e 'name)
                 (woo-get-option e 'state)))
         (woo-list (string-append "/packages/groups/" group)))
        (lambda (a b) (string< (car a) (car b)))))

(define (groups-elt elt)
  (woo-first-command
   (woo-read
    (string-append "/packages/groups/"
                   (cell-ref *groups-major-current*)  "/" elt))))

(define (groups-elt-version elt)
  (woo-get-option (groups-elt elt) 'version))

(define (groups-elt-summary elt)
  (woo-get-option (groups-elt elt) 'summary))

(define (groups-elt-description elt)
  (woo-get-option (groups-elt elt) 'description))

(define (groups-elt-state elt)
  (let* ((state (assoc-ref (cell-ref *groups-minor-current*) elt))
         (command (cond ((or (string=? state "locked")
                             (string=? state "available")
                             (string=? state "upgradable")
                             (string=? state "be-removed")) "install")
                        ((or (string=? state "installed")
                             (string=? state "be-upgraded")
                             (string=? state "be-installed")) "remove"))))
    (woo-write
     (string-append "/packages/state/" elt) 'state command)
    (list command elt)))

;------------------------------------------------------------------------------
`(groups
  (label . ,(_ "Groups"))
  (type . static)
  (sort . ,string<)
  (major . ,groups-major)
  (minor . ,groups-minor)
  (elt-version . ,groups-elt-version)
  (elt-summary . ,groups-elt-summary)
  (elt-description . ,groups-elt-description)
  (elt-state . ,groups-elt-state))
