(document:envelop let () )

(define *pending-major-current* (make-cell #f))
(define *pending-minor-current* (make-cell #f))

;(define *pending-major-labels*
;  (list (_ "keep") (_ "install") (_ "remove") (_ "upgrade") (_ "essential")))

;---------------------------------------------------------------
(define *pending-major-labels*
  `(("keep" . ,(_ "Be Kept"))
    ("install" . ,(_ "Be Installed"))
    ("remove" . ,(_ "Be Removed"))
    ("upgrade" . ,(_ "Be Upgraded"))
    ("essential" . ,(_ "Important"))))

(define *pending-major-labels-rev*
  (map (lambda (e) (cons (cdr e) (car e)))
       *pending-major-labels*))

(define (pending-major->label major)
  (assoc-ref *pending-major-labels* major))

(define (pending-label->major label)
  (assoc-ref *pending-major-labels-rev* label))
;---------------------------------------------------------------

(define *pending-major-states*
  '(("keep" . "upgradable")
    ("install" . "be-installed")
    ("remove" . "be-removed")
    ("essential" . "be-removed")
    ("upgrade" . "be-upgraded")))

(define (pending-major->state major)
  (assoc-ref *pending-major-states* major))

(define (pending-major)
  (map pending-major->label
       (sort (woo-list-names "/packages/pending") string<)))

;(define (pending-major) (woo-list-names "/packages/pending"))

(define (pending-minor label)
  (cell-set! *pending-major-current* (pending-label->major label))
  (cell-set! *pending-minor-current*
             (pending-minor-1 (cell-ref *pending-major-current*)))
  (cell-ref *pending-minor-current*))

(define (pending-minor-1 major)
  (if major
      (map
       (lambda (e) (cons e (pending-major->state major)))
       (sort
        (woo-list-names
         (string-append "/packages/pending/" major))
        string<))
      '()))

(define (pending-elt elt)
  (woo-read-first
   (string-append "/packages/pending/"
                  (cell-ref *pending-major-current*)  "/" elt)))

(define (pending-elt-version elt)
  (or (and (string=? "" elt) "")
      (woo-get-option (pending-elt elt) 'version)))

(define (pending-elt-summary elt)
  (or (and (string=? "" elt) "")
      (woo-get-option (pending-elt elt) 'summary)))

(define (pending-elt-description elt)
  (or (and (string=? "" elt) "")
      (woo-get-option (pending-elt elt) 'description)))

(define (pending-elt-state elt)
  (let* ((state (assoc-ref (cell-ref *pending-minor-current*) elt))
         (command (cond ((or (string=? state "locked")
                             (string=? state "available")
                             (string=? state "upgradable")
                             (string=? state "be-removed")) "install")
                        ((or (string=? state "installed")
                             (string=? state "be-installed")
                             (string=? state "be-upgraded")) "remove"))))
    (woo-write
     (string-append "/packages/state/" elt) 'state command)
    (list command elt)))

;------------------------------------------------------------------------------
`(pending
  (label . ,(_ "Pending"))
  (type . dynamic)
  (sort . ,string<)
  (major . ,pending-major)
  (minor . ,pending-minor)
  (elt-version . ,pending-elt-version)
  (elt-summary . ,pending-elt-summary)
  (elt-description . ,pending-elt-description)
  (elt-state . ,pending-elt-state))
