(document:envelop let () )

(define *search-major* (make-cell '()))
(define *search-major-current* (make-cell #f))
(define *search-minor-current* (make-cell #f))

(define (search-add major)
  (or (string=? major "")
      (member major (cell-ref *search-major*))
      (cell-set! *search-major* (cons major (cell-ref *search-major*)))))

(define (search-major)
  (cell-ref *search-major*))

(define (search-minor major)
  (cell-set! *search-major-current* major)
  (cell-set! *search-minor-current*
             (search-minor-1 major))
  (cell-ref *search-minor-current*))

(define (search-minor-1 major)
  (sort (map
         (lambda (e)
           (cons (woo-get-option e 'name)
                 (woo-get-option e 'state)))
         (woo-list (string-append "/packages/search/" major)))
        (lambda (a b) (string< (car a) (car b)))))

(define (search-elt elt)
  (woo-read-first
   (string-append "/packages/search/"
                  (cell-ref *search-major-current*)  "/" elt)))

(define (search-elt-version elt)
  (or (and (string=? "" elt) "")
      (woo-get-option (search-elt elt) 'version)))

(define (search-elt-summary elt)
  (if (string=? elt "") ""
      (woo-get-option (search-elt elt) 'summary)))

(define (search-elt-description elt)
  (if (string=? elt "") ""
      (woo-get-option (search-elt elt) 'description)))

(define (search-elt-state elt)
  (let* ((state (assoc-ref (cell-ref *search-minor-current*) elt))
         (command (cond ((or (string=? state "locked")
                             (string=? state "available")
                             (string=? state "upgradable")
                             (string=? state "be-removed")) "install")
                        ((or (string=? state "installed")
                             (string=? state "be-installed")
                             (string=? state "be-upgraded")) "remove"))))
    (woo-write
     (string-append "/packages/state/" elt) 'state command)
    (list command elt)))

;------------------------------------------------------------------------------
`(search
  (label . ,(_ "Search"))
  (type . dynamic)
  (add . ,search-add)
  (sort . ,(lambda x #f))
  (major . ,search-major)
  (minor . ,search-minor)
  (elt-version . ,search-elt-version)
  (elt-summary . ,search-elt-summary)
  (elt-description . ,search-elt-description)
  (elt-state . ,search-elt-state))

